#include "stdafx.h"
#include "NTLogon.h"
#include "NTLogonDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CNTLogonDlg::CNTLogonDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNTLogonDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNTLogonDlg)
	m_sDomain = _T("");
	m_bEnable = FALSE;
	m_sPassword = _T("");
	m_sUser = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNTLogonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNTLogonDlg)
	DDX_Text(pDX, IDC_DOMAIN, m_sDomain);
	DDX_Check(pDX, IDC_ENABLE, m_bEnable);
	DDX_Text(pDX, IDC_PASSWORD, m_sPassword);
	DDX_Text(pDX, IDC_USER, m_sUser);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNTLogonDlg, CDialog)
	//{{AFX_MSG_MAP(CNTLogonDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_DOMAIN, OnChangeDomain)
	ON_EN_CHANGE(IDC_PASSWORD, OnChangePassword)
	ON_EN_CHANGE(IDC_USER, OnChangeUser)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_BN_CLICKED(IDAPPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CNTLogonDlg::OnInitDialog()
{
  BYTE  bBuffer[_MAX_PATH];

  //Get the "AutoAdminLogon" value
  DWORD dwSize = _MAX_PATH;
  DWORD dwType;
  if (RegQueryValueEx(GetApp()->m_hKeyWinLogon, _T("AutoAdminLogon"), NULL, &dwType, bBuffer, &dwSize) == ERROR_SUCCESS)
  {
    if (dwType == REG_SZ)
      m_bEnable = (_tcscmp((LPCTSTR) bBuffer, _T("1")) == 0);
  }  

  //Get the "DefaultDomainName" value
  dwSize = _MAX_PATH;
  if (RegQueryValueEx(GetApp()->m_hKeyWinLogon, _T("DefaultDomainName"), NULL, &dwType, bBuffer, &dwSize) == ERROR_SUCCESS)
    m_sDomain = (LPCTSTR) bBuffer;

  //Get the "DefaultUserName" value
  dwSize = _MAX_PATH;
  if (RegQueryValueEx(GetApp()->m_hKeyWinLogon, _T("DefaultUserName"), NULL, &dwType, bBuffer, &dwSize) == ERROR_SUCCESS)
    m_sUser = (LPCTSTR) bBuffer;

  //Get the "DefaultPassword" value
  dwSize = _MAX_PATH;
  if (RegQueryValueEx(GetApp()->m_hKeyWinLogon, _T("DefaultPassword"), NULL, &dwType, bBuffer, &dwSize) == ERROR_SUCCESS)
    m_sPassword = (LPCTSTR) bBuffer;

	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

  //remove the maximize option
  pSysMenu->RemoveMenu(SC_MAXIMIZE, MF_BYCOMMAND);

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

  return TRUE;
}

void CNTLogonDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CNTLogonDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CNTLogonDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNTLogonDlg::OnChangeDomain() 
{
	GetDlgItem(IDAPPLY)->EnableWindow(TRUE);	
}

void CNTLogonDlg::OnChangePassword() 
{
	GetDlgItem(IDAPPLY)->EnableWindow(TRUE);	
}

void CNTLogonDlg::OnChangeUser() 
{
	GetDlgItem(IDAPPLY)->EnableWindow(TRUE);	
}

void CNTLogonDlg::OnEnable() 
{
	GetDlgItem(IDAPPLY)->EnableWindow(TRUE);	
}

void CNTLogonDlg::OnApply() 
{
	if (UpdateData())
  {
    //Set the "AutoAdminLogon" value
    TCHAR sBuffer[_MAX_PATH];
    if (m_bEnable)
      _tcscpy(sBuffer, _T("1"));
    else
      _tcscpy(sBuffer, _T("0"));

    if (RegSetValueEx(GetApp()->m_hKeyWinLogon, _T("AutoAdminLogon"), NULL, REG_SZ, (const LPBYTE) sBuffer, 2) != ERROR_SUCCESS)
    {
      AfxMessageBox(IDS_FAIL_WRITE_REGISTRY);
      return;
    }

    //Set the "DefaultDomainName" value
    if (RegSetValueEx(GetApp()->m_hKeyWinLogon, _T("DefaultDomainName"), NULL, REG_SZ, (const LPBYTE) (LPCTSTR) m_sDomain, m_sDomain.GetLength()+1) != ERROR_SUCCESS)
    {
      AfxMessageBox(IDS_FAIL_WRITE_REGISTRY);
      return;
    }

    //Set the "DefaultUserName" value
    if (RegSetValueEx(GetApp()->m_hKeyWinLogon, _T("DefaultUserName"), NULL, REG_SZ, (const LPBYTE) (LPCTSTR) m_sUser, m_sUser.GetLength()+1) != ERROR_SUCCESS)
    {
      AfxMessageBox(IDS_FAIL_WRITE_REGISTRY);
      return;
    }

    //Set the "DefaultPassword" value
    if (RegSetValueEx(GetApp()->m_hKeyWinLogon, _T("DefaultPassword"), NULL, REG_SZ, (const LPBYTE) (LPCTSTR) m_sPassword, m_sPassword.GetLength()+1) != ERROR_SUCCESS)
    {
      AfxMessageBox(IDS_FAIL_WRITE_REGISTRY);
      return;
    }

    GetDlgItem(IDAPPLY)->EnableWindow(FALSE);		
  }
}

